# ModifyInstanceType

## 1. API Description

This API (ModifyInstanceType) is used to modify the type of an elastic compute instance.

{% hint style="info" %} <mark style="color:blue;">**Note**</mark>

<mark style="color:blue;">You can only perform this operation on instances whose status is</mark> <mark style="color:blue;">`STOPPED`</mark><mark style="color:blue;">.</mark>
{% endhint %}

## 2. Input Parameters

The following request parameter list only provides API request parameters.

| Parameter Name | Required | Type   | Description                                                                                                                                                      |
| -------------- | -------- | ------ | ---------------------------------------------------------------------------------------------------------------------------------------------------------------- |
| instanceId     | Yes      | String | <p>Instance ID.</p><p>To obtain the instance ID, you can call DescribeInstances and look for instanceId in the response.</p>                                     |
| instanceType   | Yes      | String | <p>The instance type ID to replace.</p><p>To obtain the instance ID, you can call DescribeZoneInstanceConfigInfos and look for instanceType in the response.</p> |

## 3. Output Parameters

| Parameter Name | Type   | Description                                                                                                           |
| -------------- | ------ | --------------------------------------------------------------------------------------------------------------------- |
| requestId      | String | <p>The unique request ID, which is returned for each request.</p><p>RequestId is required for locating a problem.</p> |

## 4. Code Example

{% tabs %}
{% tab title="Example" %}
**Modify the type of the instance.**

```javascript
POST /api/v2/zec HTTP/1.1
Host: console.zenlayer.com
Content-Type: application/json
X-ZC-Action: ModifyInstanceType
<Common Request Params>

Request：
{
  "instanceId": "instanceId",
  "instanceType": "xxx"
}

Response：
{
  "requestId": "T05992D0C-7E8B-4047-B0C0-780F2CD549D3",
  "response": {  
    "requestId": "T05992D0C-7E8B-4047-B0C0-780F2CD549D3"
  }
}
```

{% endtab %}
{% endtabs %}

## 5. Developer Resources

Zenlayer Cloud API 2.0 integrates [SDKs](https://docs.console.zenlayer.com/api-reference/api-introduction/toolkit/api-sdk)，to make it easier for you to call APIs. More programming languages will be supported.

## 6. Error Codes

The following only lists the error codes related to the API business logic. For other error codes, see [Common Error Codes](https://docs.console.zenlayer.com/api-reference/api-introduction/instruction/commonerrorcode).

| HTTP Status Code | Error Code                                        | Description                                                     |
| ---------------- | ------------------------------------------------- | --------------------------------------------------------------- |
| 404              | INVALID\_INSTANCE\_NOT\_FOUND                     | Instance not found.                                             |
| 404              | INVALID\_INSTANCE\_TYPE\_NOT\_FOUND               | Instance type not found.                                        |
| 400              | OPERATION\_DENIED\_GPU\_INSTANCE\_NOT\_SUPPORT    | GPU instances are not supported for custom image creation.      |
| 400              | OPERATION\_DENIED\_INSTANCE\_STATUS\_NOT\_SUPPORT | Current instance state does not allow this operation.           |
| 400              | OPERATION\_FAILED\_INSTANCE\_TYPE\_UNSUPPORTED    | The specified instance type is not supported for this instance. |
